/*********************************************************
       Hazirlayan :     Beycan Kahraman - 040020337
*********************************************************/

#include 	<iostream>
#include 	<stdio.h>
#include 	<stdlib.h>
#include 	<math.h>

#define 	MAX 		4
#define 	h 			0.001

using 		namespace 	std;

/*********************************************************
   Asagidaki fonksiyon istenen bir polinomun (Dizi),
        istenen noktasi icin F(x) degerini ve 
   tum turevlerini (turev = derecesi) bulabilmektedir
*********************************************************/

double F(double x, int dizi[], int turev = 0){
	if(turev >= MAX)
		return 0;
	double sonuc = 0.0, ekle;
	for(int i=0; i<MAX - turev; i++){
		ekle = 1.0;
		for(int j=0; j<i; j++)
			ekle *= x;
		ekle *= dizi[MAX - i - 1 - turev];
		for(int j=0; j<turev; j++)
			ekle *= i+turev-j;
		sonuc += ekle;
	}
	return sonuc;
}

int main(){ 
	int Dizi[] = {3,-4,5,-6,7,-2,8,-1,9,-8,12,-10,3,-5}; // Ornek Polinom
	double x = 5, a, b; // x=5  nokttasi icin aranan degerler hesaplanacak
	
	cout << "-------------------------------" << endl; // F(x)
	a = F(x, Dizi);
	printf("F(x)\n%5.8f\n",a);
	
	cout << "-------------------------------" << endl; // F'(x)
	a = F(x, Dizi, 1);
	b = ( F(x+h, Dizi) - F(x-h, Dizi) ) / ( 2*h );
	printf("F'(x)\n%5.8f\n",a);
	printf("%5.8f\n",b);
	
	cout << "-------------------------------" << endl; // F''(x)
	a = F(x, Dizi, 2);
	b = ( F(x+h, Dizi) - 2*F(x, Dizi) + F(x-h, Dizi) ) / ( h*h );
	printf("F''(x)\n%5.8f\n",a);
	printf("%5.8f\n",b);
	
	cout << "-------------------------------" << endl; // F'''(x)
	a = F(x, Dizi, 3);
	b = ( -F(x-h, Dizi) + 3*F(x, Dizi) - 3*F(x+h, Dizi) + F(x+2*h, Dizi) ) / (h*h*h);
	printf("F'''(x)\n%5.8f\n",a);
	printf("%5.8f   -> Istenen  Cozum\n",b);
	b = 3 * ( -F(x-h, Dizi) + 3*F(x, Dizi) - 3*F(x+h, Dizi) + F(x+2*h, Dizi) ) / (h*h*h);
	printf("%5.8f   -> Buldugum Cozum\n",b);
	cout << "-------------------------------" << endl;
	
    system("PAUSE"); // Bitti!..
    return 0;
}

